module CGA.Box(  --This is the Attributed box module.
  mkBox, 
  Box(Box),
  set, 
  title, 
  doOnActivate,
  position, 
  size, 
  (=:),
) where

import Fl.Box

import Attributes

import CGA.CommonSignals
import CGA.CommonAttributes
import CGA.Widget

data Box = Box BoxPtr

instance IsWidget Box where
  toWidget (Box b) = do
    a <- box_to_Widget b
    return (mkWidget a)


--Converts the Box to a box pointer (simply for convinience)
b2A (Box a) = a

-- The Box constructor
mkBox :: [Prop Box] -> IO Box
mkBox props = do
  a <- newBox 0 0 300 200 ""
  let w = Box a
  set w props
  return w

instance HasTitle Box where
  title = newAttr (\w   -> box_memfun_getLabel (b2A w) )
                  (\w x -> box_memfun_setLabel (b2A w) x)

instance HasPosition Box where
  position = newAttr 
    (\w  -> 
      do
        a <- box_memfun_x (b2A w)
        b <- box_memfun_y (b2A w)
        return (a,b) )
    (\w (a,b) -> box_memfun_position (b2A w) a b )

instance HasSize Box where
  size = newAttr 
    (\w  -> 
      do
        a <- box_memfun_w (b2A w)
        b <- box_memfun_h (b2A w)
        return (a,b) )
    (\w (a,b) -> box_memfun_size (b2A w) a b )
