module CGA.Button(  --This is the Attributed button module.
  mkButton, 
  Button(Button),
  set, 
  title, 
  doOnActivate,
  position, 
  size, 
  (=:),
) where

import Fl.Button

import Attributes

import CGA.CommonSignals
import CGA.CommonAttributes
import CGA.Widget

data Button = Button ButtonPtr

instance IsWidget Button where
  toWidget (Button b) = do
    a <- button_to_Widget b
    return (mkWidget a)


--Converts the Button to a button pointer (simply for convinience)
b2A (Button a) = a

-- The Button constructor
mkButton :: [Prop Button] -> IO Button
mkButton props = do
  a <- newButton 0 0 300 50 "Button"
  let w = Button a
  set w props
  return w

instance HasTitle Button where
  title = newAttr (\w   -> button_memfun_getLabel (b2A w) )
                  (\w x -> button_memfun_setLabel (b2A w) x)

instance HasOnActivate Button where
  doOnActivate button callback = 
    do
      button_memfun_callback (b2A button) callback
      return (button_memfun_callback (b2A button) (return ()))

instance HasPosition Button where
  position = newAttr 
    (\w  -> 
      do
        a <- button_memfun_x (b2A w)
        b <- button_memfun_y (b2A w)
        return (a,b) )
    (\w (a,b) -> button_memfun_position (b2A w) a b )

instance HasSize Button where
  size = newAttr 
    (\w  -> 
      do
        a <- button_memfun_w (b2A w)
        b <- button_memfun_h (b2A w)
        return (a,b) )
    (\w (a,b) -> button_memfun_size (b2A w) a b )
