module CGA.Window(mkWindow,Window(Window),children,addChild,visible) where

import CGA.Widget
import CGA.CommonAttributes
import CGA.CommonMembers

import Fl.Window

import Attributes
import Monad

--A WindowPtr and a list of children
data Window = Window (WindowPtr)

instance IsWidget Window where
  toWidget (Window b) = do
    a <- window_to_Widget b
    return (mkWidget a)

instance HasAddChild Window where
  addChild (Window winptr) isWidget = do 
    (Widget widgetPtr) <- toWidget isWidget
    window_memfn_add winptr widgetPtr


w2A (Window a ) = a

mkWindow :: [Prop Window] -> IO Window
mkWindow props = do
  a <- newWindow 300 200
  let w = Window a 
  set w props
  return w

instance HasChildren Window where
  children = newAttr
   (\(Window a ) -> return ([] :: [Widget]))
   (\w x -> mapM_ (window_memfn_add (w2A w)) $ map aToF x )

visible = newAttr
   (\(Window a ) -> window_memfun_visible a )
   (\(Window a ) bool -> if (bool) then
                                   window_memfun_show a
                               else
                                   window_memfun_hide a )
