module Fl.Box  where

import Foreign
import Foreign.C
import Foreign.C.String
import Fl.Widget

data F_Box = F_Box ()

data BoxPtr = BoxPtr (ForeignPtr F_Box)

foreign import ccall f_newBox :: Int -> Int -> Int -> Int -> CString -> IO (Ptr F_Box)
foreign import ccall f_deleteBox :: (Ptr F_Box) -> IO ()
foreign import ccall f_Box_memfn_setLabel :: Ptr F_Box -> CString -> IO ()
foreign import ccall f_Box_memfn_getLabel :: Ptr F_Box -> IO( CString )
foreign import ccall f_Box_memfn_position :: Ptr F_Box -> Int -> Int -> IO( )
foreign import ccall f_Box_memfn_size :: Ptr F_Box -> Int -> Int -> IO( )
foreign import ccall f_Box_memfn_x :: Ptr F_Box -> IO( Int )
foreign import ccall f_Box_memfn_y :: Ptr F_Box -> IO( Int )
foreign import ccall f_Box_memfn_w :: Ptr F_Box -> IO( Int )
foreign import ccall f_Box_memfn_h :: Ptr F_Box -> IO( Int )

newBox :: Int -> Int -> Int -> Int -> String -> IO BoxPtr
newBox a b c d e = do
  thestring <- newCString e
  it <- f_newBox a b c d thestring
  fptr <- newForeignPtr it (f_deleteBox it)
  return (BoxPtr fptr)

box_to_Widget :: BoxPtr -> IO( WidgetPtr )
box_to_Widget (BoxPtr b) =
  return $ newWidgetPtr (castForeignPtr b)


box_memfun_setLabel a s = do
   let BoxPtr  b = a
   cstring <- newCString s
   f_Box_memfn_setLabel (foreignPtrToPtr b) cstring
   touchForeignPtr b
   return ()

box_memfun_getLabel a = do
   let BoxPtr  b = a
   cstring <- f_Box_memfn_getLabel (foreignPtrToPtr b)
   touchForeignPtr b
   peekCString cstring

box_memfun_position a x y = do
   let BoxPtr  b = a
   f_Box_memfn_position (foreignPtrToPtr b) x y
   touchForeignPtr b

box_memfun_size a x y = do
   let BoxPtr  b = a
   f_Box_memfn_size (foreignPtrToPtr b) x y
   touchForeignPtr b

box_memfun_x a = do
   let BoxPtr  b = a
   a <- f_Box_memfn_x (foreignPtrToPtr b)
   touchForeignPtr b
   return a

box_memfun_y a = do
   let BoxPtr  b = a
   a <- f_Box_memfn_y (foreignPtrToPtr b)
   touchForeignPtr b
   return a

box_memfun_w a = do
   let BoxPtr  b = a
   a <- f_Box_memfn_w (foreignPtrToPtr b)
   touchForeignPtr b
   return a

box_memfun_h a = do
   let BoxPtr  b = a
   a <- f_Box_memfn_h (foreignPtrToPtr b)
   touchForeignPtr b
   return a

