module Main(main) where

import CGA
import CGA.Window
import CGA.Button
import CGA.Widget
import CGA.Box

import Attributes
import Control.Concurrent.MVar

helloPressed button boolean = do
  thebool <- readMVar boolean
  if (thebool == True) then do
      set button [ title =: "World" ]
      modifyMVar_ boolean (\a -> return False)
    else do
      set button [ title =: "Hello" ]
      modifyMVar_ boolean (\a -> return True)

main = runCGA $ do
    window <- mkWindow []
    box <- mkBox [ size =: (300,200), title =: "Hello, World!" ]
    hello <- mkButton [ title =: "Hello", position =: (10,0), size =: (280,50) ]

    boolean  <- newMVar True
    doOnActivate hello (helloPressed hello boolean)

    exitButton <- mkButton [ title =: "Exit", position =: (0,150), 
                             size =: (300,50) ]
    doOnActivate exitButton (exit 1)

    a <- toWidget hello
    set window [ children =: [a], visible =: True ]
    addChild window exitButton
    addChild window box
